package com.bergerkiller.bukkit.nolagg;

import net.minecraft.server.EntityPlayer;
import net.minecraft.server.Packet;
import net.minecraft.server.TileEntity;

import org.bukkit.Chunk;
import org.bukkit.World;
import org.bukkit.craftbukkit.CraftChunk;
import org.bukkit.craftbukkit.CraftWorld;

import com.bergerkiller.bukkit.nolagg.sending.BufferedPacket51MapChunk;

public class ChunkHandler {	

	public static net.minecraft.server.Chunk getNative(Chunk chunk) {
		return ((CraftChunk) chunk).getHandle();
	}
	public static net.minecraft.server.WorldServer getNative(World world) {
		return ((CraftWorld) world).getHandle();
	}
	public static String toString(Chunk chunk) {
		return "[" + chunk.getX() + "/" + chunk.getZ() + "/" + chunk.getWorld().getName() + "]";
	}
	public static String toString(net.minecraft.server.Chunk chunk) {
		return "[" + chunk.x + "/" + chunk.z + "/" + chunk.world.getWorld().getName() + "]";
	}

	public static boolean transferData(net.minecraft.server.Chunk from, net.minecraft.server.Chunk to) {
		try {
			to.b = from.b;
			to.g = from.g;
			to.h = from.h;
			to.i = from.i;
			to.heightMap = from.heightMap;
			to.done = from.done;
			return true;
		} catch (Throwable t) {
			t.printStackTrace();
			return false;
		}
	}
	
	public static boolean canSave(net.minecraft.server.Chunk chunk) {
		return chunk.a(false) && chunk.world.getWorld().isAutoSave();
	}
		
	public static void sendChunk(net.minecraft.server.Chunk c, EntityPlayer player) {
		new BufferedPacket51MapChunk(c).send(player);
		Packet p;
		for (Object o : c.tileEntities.values()) {
			p = ((TileEntity) o).k();
			if (p != null) player.netServerHandler.sendPacket(p);
		}
	}
				
}
